//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#pragma once
#include "types.h"
#include "KnownFile.h"
#include "memcpy_amd.h"
#include <math.h>

typedef 	int (__cdecl *SortFunction)(const void *, const void *);

#define _WINVER_NT4_	0x0004
#define _WINVER_95_		0x0004
#define _WINVER_98_		0x0A04
#define _WINVER_ME_		0x5A04
#define _WINVER_2K_		0x0005
#define _WINVER_XP_		0x0105
#define _WINVER_SE_		0x0205

#define ROUND(x) (floor((float)x+0.5f))

#ifdef _DEBUG
// obaldin: no point crashing here
#define OUTPUT_DEBUG_TRACE() { \
    try{ \
	CString strTrace; \
	strTrace.Format(_T("%s:%d, %s\n"), strrchr(__FILE__, '\\') + 1, __LINE__, __FUNCTION__); \
	OutputDebugString(strTrace); \
    } catch(...){} \
}
#else
#define OUTPUT_DEBUG_TRACE() ((void)0)
#endif

CString CastItoXBytes(uint64 count);
CString CastItoIShort(uint64 number);
CString CastSecondsToHM(sint32 seconds);
CString FileHashToString(const uchar *hash); 
CString LeadingZero(uint32 units);
void 	ShellOpenFile(const CString& name); //<<--9/21/02
CString GetResString(UINT uStringID);//<<--10/01/02
CString GetResString(UINT uStringID,WORD languageID);

CString URLEncode(CString sIn);
inline 	BYTE toHex(const BYTE &x);
CString GetFiletypeByName(const CString& infile);
bool CheckIsRegistrySet();
bool Ask4RegFix(bool dontAsk = false); // Barry - Allow forced update without prompt
void BackupReg(void); // Barry - Store previous values
void RevertReg(void); // Barry - Restore previous values
int 	GetMaxConnections();
CString MakeStringEscaped(CString in);
void	UpdateURLMenu(CMenu &menu, int &counter);
void RunURL(CAbstractFile* file,CString urlpattern);

WORD	DetectWinVersion(BOOL &bNTBased);
_int64	GetFreeDiskSpaceX(LPCTSTR pDirectory);
HICON	LoadImgLstIcon(LPCTSTR lpszName, int cx, int cy);
//For Rate File 
CString GetRateString(uint16 rate);
void	UpdateURLMenu(CMenu &menu, int &counter);

// From Gnucleus project [found by Tarod]
CString EncodeBase32(const unsigned char* buffer, unsigned int bufLen);
CString EncodeBase16(const unsigned char* buffer, unsigned int bufLen);
int	DecodeLengthBase16(int base16Length);
void DecodeBase16(LPCTSTR base16Buffer, unsigned int base16BufLen, byte *buffer);
CString StringLimit(const CString& in,uint16 length);
// Returns client version string based on client type
CString GetClientVersionString(eClientTypes clientype,uint32 uVersion);
// returns download queue client status based as string
CString GetStatusDLQueueString(eDLQState State);
// returns upload queue client status based as string
CString GetStatusULQueueString(eULQState State);
// returns client type as string
CString GetClientNameString(eClientTypes clienttype);
CString GetClientNameAndVersionString(CUpDownClient *client);
CString BrowseFolder(HWND hwndOwner, LPCTSTR pszTitle, LPCTSTR pszStartFolder); //<<-- enkeyDEV(Ottavio84) -ChangeDir-
CString DialogBrowseFile(CString Filters, CString DefaultFileName="");
//SyruS: cleanup
CString URLDecode(CString inStr);
CString LeadingCaps(CString inStr, CString exceptStr=_T(""));
CString DeleteNonAlphaNumeric(CString inStr, CString exceptStr=_T("") , bool onlyRep=true);
CString ReplaceDotsWithSpaces(CString inStr, CString exceptStr=_T(""), CString addClear=_T(""), bool keepExt=false);
CString CleanupFilename(CString filename);
CString GetErrorMessage(CException* e);

// md4cmp -- replacement for memcmp(hash1,hash2,16)
// Like 'memcmp' this function returns 0, if hash1==hash2, and !0, if hash1!=hash2.
// NOTE: Do *NOT* use that function for determining if hash1<hash2 or hash1>hash2.
__inline int md4cmp(const void* hash1, const void* hash2) {
	return !(((uint32*)hash1)[0] == ((uint32*)hash2)[0] &&
		     ((uint32*)hash1)[1] == ((uint32*)hash2)[1] &&
		     ((uint32*)hash1)[2] == ((uint32*)hash2)[2] &&
		     ((uint32*)hash1)[3] == ((uint32*)hash2)[3]);
}

// md4clr -- replacement for memset(hash,0,16)
__inline void md4clr(const void* hash) {
	((uint32*)hash)[0] = ((uint32*)hash)[1] = ((uint32*)hash)[2] = ((uint32*)hash)[3] = 0;
}

// md4cpy -- replacement for memcpy(dst,src,16)
__inline void md4cpy(void* dst, const void* src) {
	((uint32*)dst)[0] = ((uint32*)src)[0];
	((uint32*)dst)[1] = ((uint32*)src)[1];
	((uint32*)dst)[2] = ((uint32*)src)[2];
	((uint32*)dst)[3] = ((uint32*)src)[3];
}

#define	MAX_HASHSTR_SIZE (16*2+1)
CString md4str(const uchar* hash);
void md4str(const uchar* hash, char* pszHash);

__inline CompareUnsigned(uint32 uSize1, uint32 uSize2)
{
	if (uSize1 < uSize2)
		return -1;
	if (uSize1 > uSize2)
		return 1;
	return 0;
}

inline CString GetPathToFile(const CString& p)
{
	TCHAR drive[_MAX_DRIVE];
	TCHAR dir[_MAX_DIR];
	
	_tsplitpath(p, drive, dir, NULL, NULL);

	return CString(drive) + dir;
}

inline CString GetFileExtension(const CString& p)
{	
	TCHAR ext[_MAX_EXT];
	_tsplitpath(p, NULL, NULL, NULL, ext);
	return CString(ext);
}

inline CString RemoveFileExtension(const CString& p)
{
	TCHAR drive[_MAX_DRIVE];
	TCHAR dir[_MAX_DIR];
	TCHAR fname[_MAX_FNAME];

	_tsplitpath(p, drive, dir, fname, NULL);

	return CString(drive) + dir + fname;
}

#ifdef UNICODE
unsigned long inet_addr(LPCTSTR cp);
#endif